/* liblcd.c (C) 2001 Georg Lukas <georg@boerde.de>; linux on dbox2 project */

#include <sys/types.h>
#include <fcntl.h>

#include "liblcd.h"



int lcd_open() {
	int lcd_fd, res, mode;
	res = open("/dev/dbox/lcd0",O_RDWR);
	if (res < 0) return -1;

	lcd_fd = res;

	mode = LCD_MODE_BIN;
	res = ioctl(lcd_fd,LCD_IOCTL_ASC_MODE,&mode);
	if (res < 0) return -2;

	return lcd_fd;
}


int lcd_close(int lcd_fd) {
	int res, mode;

	lcd_clr(lcd_fd);
	mode = LCD_MODE_ASC;
	res = ioctl(lcd_fd,LCD_IOCTL_ASC_MODE,&mode);

	return close(lcd_fd);
}

int lcd_clr(int lcd_fd) {
	return ioctl(lcd_fd,LCD_IOCTL_CLEAR);
}


int lcd_write(int lcd_fd, lcd_packed_buffer s) {
	return (write(lcd_fd, s, LCD_BUFFER_SIZE)==LCD_BUFFER_SIZE)?0:-1;
}

void lcd_putpixel(int x, int y, char col, lcd_packed_buffer s) {
	int bit = y & 7;

	switch (col) {
	case LCD_PIXEL_ON:
		s[y>>3][x] |= 1<<bit;
		break;
	case LCD_PIXEL_OFF:
		s[y>>3][x] &= ~(1<<bit);
		break;
	case LCD_PIXEL_INV:
		s[y>>3][x] ^= 1<<bit;
		break;
	}
}
